----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    16:19:36 07/27/2016 
-- Design Name: 
-- Module Name:    rs_ff - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;


entity rs_ff is 
	port (
		clk: in std_logic;
		clk_en: in std_logic;
		R, S: in std_logic;
		Q: out std_logic := '0';
		Qn: out std_logic := '1'
	);
end rs_ff;

architecture rs_behav of rs_ff is
begin
	process (clk, clk_en)
	begin
      if rising_edge(clk) and clk_en = '1' then
			if (S='1' and R='0') then Q <= '1'; Qn <= '0';
			elsif (S='0' and R='1') then Q <= '0'; Qn <= '1';
			else 
				-- Q <= Q; Qn <= Qn;
			end if;
		end if;
	end process;
end rs_behav;

-- Alternative implementation.
-- Note that this is state-sensitive to the clock, not edge-sensitive (active low).
--
--architecture rs_struct of rs_ff is
--begin
--	Qn <= (S and not clk) nor Q;
--	Q  <= (R and not clk) nor Qn;
--end rs_struct;

